package com.networksByteDesign.util;

// Ant libraries
import org.apache.tools.ant.types.Parameter;
import org.apache.tools.ant.filters.BaseParamFilterReader;
import org.apache.tools.ant.filters.ChainableReader;

// Java libraries
import java.io.IOException;
import java.io.Reader;

public final class FooFilter extends BaseParamFilterReader
    implements ChainableReader
{
    private long lineNumber = 0;

    private String queuedData = null;

    public FooFilter()
    {
        super();
    }
    
    public FooFilter(final Reader in)
    {
        super(in);
    }

    public final Reader chain(final Reader rdr)
    {
        FooFilter newFilter = new FooFilter(rdr);
        newFilter.setInitialized(true);
        return newFilter;
    }

    public final int read() throws IOException
    {
        if(!getInitialized())
        {
            setInitialized(true);
        }

        int ch = -1;

        if(queuedData != null && queuedData.length() == 0)
        {
            queuedData = null;
        }

        if(queuedData != null)
        {
            ch = queuedData.charAt(0);
            queuedData = queuedData.substring(1);
            if(queuedData.length() == 0)
            {
                queuedData = null;
            }
        }
        else
        {
            queuedData = readLine();
            lineNumber++;
            if(queuedData == null)
            {
                ch = -1;
            }
            else
            {
                queuedData = lineNumber + ". " + queuedData;
                return read();
            }
        }
        return ch;
    }
}
