package com.networksByteDesign.util;

import org.apache.tools.ant.*;
import org.apache.tools.ant.taskdefs.*;
import org.apache.tools.ant.types.*;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.FileNotFoundException;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.Vector;
import java.util.Enumeration;

public class LoadTask extends MatchingTask
{

    public void execute() throws BuildException
    {
        Vector controlList = new Vector();
        if (fileset_ != null)
        {
            DirectoryScanner ds = fileset_.getDirectoryScanner(project);
            
            String[] includedFiles = ds.getIncludedFiles();
            String cmd = null;
            
            for (int j=0; j<includedFiles.length; j++)
            {
                control_ = includedFiles[j];
                String baseControl = control_.substring(0, control_.length() - 4);
                log_  = baseControl + ".log";
                bad_  = baseControl + ".bad";
                data_ = baseControl + ".dat";
                cmd = buildCmd();
                controlList.add(cmd);
            }
        }
        else if (control_ != null)
        {
            String cmd = buildCmd();
            controlList.add(cmd);
        }
        else
        {
            throw new BuildException("no control files were specified");
        }
        // Get a handle on the JVM Runtime Object
        Runtime rt = Runtime.getRuntime();
        
        Enumeration enm = controlList.elements();
        while (enm.hasMoreElements())
        {
            String cmd = (String)enm.nextElement();
            // Execute the tool
            try
            {
                Process proc = rt.exec(cmd);
                int code = proc.waitFor();
                if ((haltonfailure_) && (code != 0))
                {
                    throw new
                        BuildException("sql loader failed with error code: "
                                       + code);
                }
            }
            catch (IOException e)
            {
                System.out.println("Caught Exception: " +e.toString());
            }
            catch (InterruptedException ie)
            {
                System.out.println("Caught Exception: " +ie.toString());
            }
        }
    }

    public void addFileset(FileSet set)
    {
        fileset_ = set;
    }
  
    public void setUserid( String userid)
    {
        userid_ = userid;
    }

    public void setHaltonfailure(String haltonfailure)
    {
        if (haltonfailure.equals("true")) {
            haltonfailure_ = true;
        }
    }

    private String buildCmd()
    {
        StringBuffer command = new StringBuffer();
        command.append("sqlldr");
        if (userid_ != null)
        {
            command.append(" -userid " + userid_);
        }

        if (control_ != null)
        {
            command.append(" -control " + control_);
            command.append(" -log " + log_);
            command.append(" -bad " + bad_);
            command.append(" -data " + data_);
        }

        return command.toString();
    }


    private FileSet fileset_;
    private String  userid_;
    private String  control_;
    private String  log_;
    private String  bad_;
    private String  data_;
    private boolean haltonfailure_ = false;
}
