<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" />

<xsl:template match="collection-file">
/*------------------------------------------------------------------------------
  File: <xsl:value-of select="returnType/className" />Collection.java
  ------------------------------------------------------------------------------*/

// ##############################################################################
// # This file is code generated by collection.xsl. Do not edit manually.
// ##############################################################################
package <xsl:value-of select="package" />;

// Application libraries
import <xsl:value-of select="returnType/package" />.<xsl:value-of select="returnType/className" />;
import <xsl:value-of select="package" />.<xsl:value-of select="returnType/className" />Iterator;

// Standard Java libraries
import java.io.Serializable;
import java.lang.StringBuffer;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

// Third Party libraries
import org.apache.log4j.Category;

/**
 * <p>
 * This class handles the maintenance of a collection of <xsl:value-of select="returnType/className" /> instances. The API includes
 * methods for adding and returning an iterator for the underlying
 * collection.
 * </p>
 */

public class <xsl:value-of select="returnType/className" />Collection implements Serializable
{
  
  ////////////////////////////////////////
  // <xsl:value-of select="returnType/className" />Collection
  ////////////////////////////////////////
  
  /**
   * Default Contructor
   */

  public <xsl:value-of select="returnType/className" />Collection()
  {
  }

  ////////////////////////////////////////
  // <xsl:value-of select="returnType/className" />Collection
  ////////////////////////////////////////
  
  /**
   * Contructor that takes a generic collection and copies the
   * contents into the newly constructed object. All contents of the
   * generic collection must be of the correct type for this class. An
   * IllegalArgumentException will be thrown if an object of an
   * incorrect type is found.
   */

  public <xsl:value-of select="returnType/className" />Collection (Collection collection) 
  {
    this();

    ObjectValidator.populated(collection, "collection");
    
    addAll(collection.iterator());
  }

  public <xsl:value-of select="returnType/className" />Collection (<xsl:value-of select="returnType/className" />Collection collection) 
  {
    this();

    ObjectValidator.populated(collection, "collection");
    
    addAll(collection.iterator());
  }

  ////////////////////////////////////////
  //addAll(Iterator)
  ////////////////////////////////////////

  /**
   * add the items specified by the iterator.
   *
   * @param values Iterator over values to add
   *
   * @return boolean true if the collection was updated, otherwise false.
   */

  public boolean addAll(Iterator values)
  {
    boolean retVal = false;

    while(values.hasNext())
    {
      try
      {
        if( getCollection().add((<xsl:value-of select="returnType/className" />) values.next()) )
        {
          retVal = true;
        }
      }
      catch (ClassCastException cce)
      {
        CAT__.error("A collection containing the wrong object type was passed to the <xsl:value-of select="returnType/className" />Collection contructor.");
        throw new IllegalArgumentException("A collection containing the wrong object type was passed to the <xsl:value-of select="returnType/className" />Collection contructor.");
      }
    }

    return retVal;
  }

  ////////////////////////////////////////
  //addAll(<xsl:value-of select="returnType/className" />Iterator)
  ////////////////////////////////////////

  /**
   * add the items specified by the iterator.
   *
   * @param values <xsl:value-of select="returnType/className" />Iterator over values to add
   *
   * @return boolean true if the collection was updated, otherwise false.
   */

  public boolean addAll(<xsl:value-of select="returnType/className" />Iterator values)
  {
    boolean retVal = false;

    while(values.hasNext())
    {
      if( getCollection().add(values.next()) )
      {
        retVal = true;
      }
    }

    return retVal;
  }

  ////////////////////////////////////////////////////////////////////////////////
  // add
  ////////////////////////////////////////////////////////////////////////////////

  /**
   *
   * <p>
   * This method adds a/an <xsl:value-of select="returnType/className" /> to the underlying collection.
   * </p>
   *
   * @param element <xsl:value-of select="returnType/className" /> instance.
   *
   * */

  public void add (<xsl:value-of select="returnType/className" /> element)
  {
    CAT__.info("... Entering add");

    ObjectValidator.populated(element, "element");

    collection_.add(element);

    CAT__.debug("Element added: " + element);
  }


  ////////////////////////////////////////////////////////////////////////////////
  // add
  ////////////////////////////////////////////////////////////////////////////////

  /**
   *
   * <p>
   * This method adds a/an <xsl:value-of select="returnType/className" /> to the underlying collection
   * at the specified position.
   * </p>
   *
   * @param element <xsl:value-of select="returnType/className" /> instance.
   * @param  insertLocation position to insert within the collection. <code>int</code>
   */

  public void add (<xsl:value-of select="returnType/className" /> element, int insertLocation)
  {
    CAT__.info("... Entering add (with insert location)");

    ObjectValidator.populated(element, "element");

    try
    {
      collection_.add(insertLocation, element);
      CAT__.debug("Element added: " + element + " at position: " + insertLocation);
    }
    catch (ArrayIndexOutOfBoundsException e)
    {
      throw new IllegalArgumentException ("Attempted to insert element into Vector at illegal position: " + insertLocation);
    }
  }

  ////////////////////////////////////////
  // remove (<xsl:value-of select="returnType/className" />)
  ////////////////////////////////////////

  /**
   * remove the specified object from the collection.
   *
   * @return boolean true if the object was in the collection, otherwise false.
   */

  public boolean remove(<xsl:value-of select="returnType/className" /> value)
  {
    ObjectValidator.populated(value, "value");

    return getCollection().remove(value);
  }

  ////////////////////////////////////////
  // contains(<xsl:value-of select="returnType/className" />)
  ////////////////////////////////////////
  
  /**
   * is the object specified in the collection
   * 
   * @param <xsl:value-of select="returnType/className" /> the value to search for
   * 
   * @return boolean true if the value is found otherwise false
   */

  public boolean contains (<xsl:value-of select="returnType/className" /> value)
  {
    ObjectValidator.populated(value, "value");

    return getCollection().contains(value);
  }

  ////////////////////////////////////////
  // indexOf(Object)
  ////////////////////////////////////////

  /**
   * Searches for the first occurance of the given argument, testing
   * for equality using the equals method.
   *
   * @param elem an Object
   *
   * @returns the index of the first occurance of argument in this
   * collection or -1 if the object is not found.
   **/

  public int indexOf(Object elem)
  {
    return getCollection().indexOf(elem);
  }

  ////////////////////////////////////////
  // clear
  ////////////////////////////////////////

  /**
   * remove all entries from the collection
   */

  public void clear()
  {
    getCollection().clear();
  }

  ////////////////////////////////////////
  // size
  ////////////////////////////////////////
  
  /**
   * Returns the number of elements in the collection
   *
   * @return the number of elements in the collection
   */
  
  public int size()
  {
    return getCollection().size();
  }
  
  ////////////////////////////////////////
  // isEmpty
  ////////////////////////////////////////
  
  /**
   * is the collection empty
   *
   * @return true if the collection is empty, otherwise false.
   */
  
  public boolean isEmpty()
  {
    return getCollection().isEmpty();
  }
  
  ////////////////////////////////////////
  // iterator
  ////////////////////////////////////////

  /**
   * returns a generic Iterator over the collection's contents
   */

  public Iterator iterator()
  {
    return getCollection().iterator();
  }

  ////////////////////////////////////////////////////////////////////////////////
  // get<xsl:value-of select="returnType/className" />Iterator
  ////////////////////////////////////////////////////////////////////////////////

  /**
   *
   * <p>
   * This method returns an iterator which can be used to access individual
   * <xsl:value-of select="returnType/className" /> instances from the underlying collection.
   * </p>
   *
   * @return <xsl:value-of select="returnType/className" />Iterator.
   *
   * */

  public <xsl:value-of select="returnType/className" />Iterator get<xsl:value-of select="returnType/className" />Iterator()
  {
    return new <xsl:value-of select="returnType/className" />Iterator(collection_.iterator());
  }


  //////////////////////////////////////////////////////////
  // getCollection
  //////////////////////////////////////////////////////////

  /**
   * <p>
   * Get the underlying collection
   * </p>
   * @return the underlying collection
   */
  private Vector getCollection()
  {
    return collection_;
  }


  //////////////////////////////////////////////////////////////////////////////
  // equals
  //////////////////////////////////////////////////////////////////////////////
  
  /**
   *  
   * <p>
   * Compares this to another <xsl:value-of select="returnType/className" />Collection object. Returns true if they 
   * represent equal objects.
   * </p>
   *
   * @param that the other object for comparison
   * @return boolean true if equal
   * */
  public boolean equals(Object that)
  {
    if ( that != null &amp;&amp; (that instanceof <xsl:value-of select="returnType/className" />Collection) )
    {
      <xsl:value-of select="returnType/className" />Collection that<xsl:value-of select="returnType/className" />Collection = (<xsl:value-of select="returnType/className" />Collection) that;
      return ( this.getCollection().equals(that<xsl:value-of select="returnType/className" />Collection.getCollection() ) );
    }
    else
    {
      return false;
    }
  }


  //////////////////////////////////////////////////////////////////////////////
  // hashCode
  //////////////////////////////////////////////////////////////////////////////

  /**
   *
   * Generates the hashcode for the enumeration based on the toString() value.
   * 
   * @return hashcode
   * 
   * */

  public int hashCode()
  {
    CAT__.info("...Entering hashCode");

    return toString().hashCode();
  }


  ////////////////////////////////////////
  // toString
  ////////////////////////////////////////

  /**
   * Return a human-readable form
   *
   * @return String
   */

  public String toString()
  {
    StringBuffer buffer = new StringBuffer();
    buffer.append(getClass().getName());
    buffer.append("(");
    Iterator iterator = iterator();
    if(iterator.hasNext())
    {
      buffer.append(iterator.next());
    }
    while(iterator.hasNext())
    {
      buffer.append(", " + iterator.next());
    }
    buffer.append(")");
    return buffer.toString();
  }

  ////////////////////////////////////////
  // Data Members
  ////////////////////////////////////////

  /** Vector to hold the elements */
  private Vector collection_ = new Vector();

  /** log4j category to use for all logging information */
  private static final Category CAT__ = Category.getInstance(<xsl:value-of select="returnType/className" />Collection.class.getName());
}
</xsl:template>
</xsl:stylesheet>
